# ParrotOS ARM builder recipe
# Device: Raspberry Pi armhf

steps:
  - mkimg: "{{ output }}"
    size: 5200M

  - mklabel: msdos
    device: "{{ output }}"

  - mkpart: primary
    fs-type: 'fat32'
    device: "{{ output }}"
    start: 4MiB
    end: 256MiB
    tag: /boot

  - mkpart: primary
    device: "{{ output }}"
    start: 256MiB
    end: 100%
    tag: /

  - kpartx: "{{ output }}"

  - mkfs: vfat
    partition: /boot
    label: BOOT

  - mkfs: ext4
    partition: /
    label: ROOTFS

  - mount: /

  - mount: /boot
    mount-on: /
    dirname: '/boot/firmware'

  - unpack-rootfs: /


  # Basic packages for core edition
  - apt: install
    packages:
    - firmware-brcm80211
    - linux-image
    - linux-headers
    - raspberrypi-bootloader
    - raspi-firmware
    - raspi-config
    tag: /

  # set-system.sh config file
  - copy-file: /tmp/set-system.sh
    src: config/set-system.sh
    perm: 755

  - copy-file: /tmp/default.conf
    src: work_dir/default.conf
    perm: 644

  - chroot: /
    shell: |
      bash /tmp/set-system.sh
      rm /tmp/set-system.sh /tmp/default.conf

  - root-fs: /
    shell: |
      # Install /boot config and fstab
      install -m 644 -o root -g root rootfs/etc/fstab "${ROOT?}/etc/fstab"
      install -m 644 -o root -g root rootfs/boot/firmware/sysconf.txt "${ROOT?}/boot/firmware/sysconf.txt"
      install -m 644 -o root -g root rootfs/boot/cmdline.txt "${ROOT?}/boot/cmdline.txt"
      install -m 644 -o root -g root rootfs/boot/config.txt "${ROOT?}/boot/config.txt"

      rsync -a --exclude=firmware --exclude=overlays ${ROOT?}/boot/ ${ROOT?}/boot/firmware/

  # Systemd service to get resize2fs working
  - copy-file: /etc/systemd/system/firstboot.service
    src: rootfs/etc/systemd/system/firstboot.service
    perm: 644

  - cache-rootfs: /
    unless: rootfs_unpacked
    
  - chroot: /
    shell: |
      systemctl enable firstboot.service ssh.service
    
  - chroot: /
    shell: |
      rm -rf /etc/machine-id /var/lib/dbus/machine-id /var/cache/apt/*
